import { expressionStatement, assignmentExpression, memberExpression, identifier, variableDeclaration, variableDeclarator, callExpression, stringLiteral, objectExpression, objectProperty } from '../../ast/builders.mjs';

var commonjs = {
  createDefaultExport(member) {
    return expressionStatement(assignmentExpression('=', memberExpression(identifier('module'), identifier('exports')), member));
  },

  createImport(members, source) {
    return variableDeclaration('const', [variableDeclarator(objectExpression(members.map(([imported, local]) => objectProperty(identifier(imported), identifier(local), false, imported === local))), callExpression(identifier('require'), [stringLiteral(source)]))]);
  }

};

export { commonjs as default };
